

#ifndef NULL
  #define  NULL    ((void *)0)
#endif


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `CollapsedRangeRep': Collapsed range of distributed arrray.   //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class CollapsedRangeRep : public RangeRep {
public :
  CollapsedRangeRep(const int _extent, const Layout _layout) ;

  RangeRep* prm() ;
  int bas() ;
  int str() ;

  //int isScalar() ;

  Subscript* subscr(const int location) ;
  int subscr(const Subscript* i) ;

  RangeRep* subrng(const int _extent, const int _base, const int _stride) ;

  StrideRep* vector(const int dataLen) ;

  void blockInit(Block& b) ;

  void locBlockInit(Block& b) ;

  void allBlocksEnum(Block& b) ;
  int  allBlocksTest(Block& b) ;
  void allBlocksNext(Block& b) ;

protected :
  Layout layout ;

private :

MEMORY_POOL_DECS
} ;


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `CollapseSubRangeRep': subrange of a collapsed range.         //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //


class CollapsedSubRangeRep : public CollapsedRangeRep {
public :
  CollapsedSubRangeRep(const int _extent, const int _base, const int _stride,
                       CollapsedRangeRep* _parent,
                       const Layout _layout) ;
  ~CollapsedSubRangeRep() ;

  RangeRep* prm() ;
  int bas() ;
  int str() ;

  Subscript* subscr(const int location) ;
  int subscr(const Subscript* i) ;

  RangeRep* subrng(const int _extent, const int _base, const int _stride) ;

  StrideRep* vector(const int dataLen) ;

  void blockInit(Block& b) ;

  void locBlockInit(Block& b) ;

protected :
  // Parent primitive range
  CollapsedRangeRep* parent ;

  // Alignment parameters
  int base ;
  int stride ;
private :

MEMORY_POOL_DECS
} ;


